/*==============================================
   This file is a part of the QENet library.
         Copyright 2012 - Nathan Osman
==============================================*/

#include <QENetPacket>
#include "QENetPacketPrivate.h"

QENetPacketPrivate::QENetPacketPrivate()
    : flags(0)
{
}

QENetPacket::QENetPacket()
    : d(new QENetPacketPrivate)
{
}

QENetPacket::QENetPacket(const QByteArray & data, quint32 flags)
    : d(new QENetPacketPrivate)
{
    setData(data);
    setFlags(flags);
}

// TODO: need to implement operator=.
QENetPacket::QENetPacket(const QENetPacket & original)
    : d(new QENetPacketPrivate)
{
    *this = original;
}

QENetPacket::~QENetPacket()
{
    delete d;
}

QByteArray QENetPacket::data() const
{
    return d->data;
}

void QENetPacket::setData(const QByteArray & data)
{
    d->data = data;
}

quint32 QENetPacket::flags() const
{
    return d->flags;
}

void QENetPacket::setFlags(quint32 flags)
{
    d->flags = flags;
}

QENetPacket & QENetPacket::operator =(const QENetPacket & rhs)
{
    *d = *rhs.d;
    return *this;
}
